<template>
  <v-container class="mb-5 mt-6" fluid>
    <v-row justify="center" align="center">
      <v-col cols="12" xl="10" sm="11">
        <h1 class="display-2 text-center primary--text mb-4">
          {{ $t('titleCertificates') }}
        </h1>
      </v-col>
    </v-row>
    <v-row justify="center" align="center">
      <v-col cols="12" xl="10" sm="11">
        <v-card>
          <v-card-text class="py-4 px-4">
            <v-row justify="center" align="center">
              <v-col
                cols="12"
                xs="12"
                :md="$store.getters['certsConfig/manualUpload'] ? 9 : 12"
                :sm="$store.getters['certsConfig/manualUpload'] ? 9 : 12"
              >
                <v-text-field
                  v-model="search"
                  :label="$t('search')"
                  required
                  outlined
                  hide-details
                ></v-text-field>
              </v-col>
              <template v-if="$store.getters['certsConfig/manualUpload']">
                <v-dialog
                  v-model="dialogNew"
                  max-width="800px"
                  scrollable
                  data-cy="dialog_new_cell"
                >
                  <template #activator="{ on }">
                    <v-col cols="12" xs="12" sm="3" md="3" class="text-center">
                      <v-btn
                        :block="$vuetify.breakpoint.smAndDown"
                        data-cy="new_cell"
                        color="primary"
                        class="text-none"
                        @click="dialogNew = true"
                        v-on="on"
                      >
                        <span style="white-space: normal">
                          {{ $t('uploadRoster') }}
                        </span>
                      </v-btn>
                    </v-col>
                  </template>
                  <UploadData
                    v-if="!$store.getters['certsConfig/isLoadingByForm']"
                    @messages="showMessages($event)"
                    @closeDialog="dialogNew = false"
                    @save="saveData($event)"
                    @paste="pastedData($event)"
                  />
                  <!-- @TODO: Change by form builder  -->
                  <keep-alive
                    v-if="$store.getters['certsConfig/isLoadingByForm']"
                  >
                    <component
                      :is="currentComponente"
                      @messages="showMessages($event)"
                      @closeDialog="dialogNew = false"
                      @save="getData"
                    ></component>
                  </keep-alive>
                </v-dialog>
              </template>
            </v-row>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-row justify="center" align="center" class="mt-3">
      <v-col cols="12" xl="10" sm="11">
        <v-card>
          <v-card-text>
            <v-row>
              <v-col cols="12" xs="12">
                <v-tabs v-model="tab" grow slider-color="primary">
                  <v-tab
                    v-if="$store.getters['certsConfig/manualUpload']"
                    :key="0"
                    :href="'#tab-0'"
                  >
                    {{ $t('roster') }}
                  </v-tab>
                  <v-tab :key="1" :href="'#tab-1'">
                    {{ $t('certificates') }}
                  </v-tab>
                  <v-tab :key="2" :href="'#tab-2'"> {{ $t('revoked') }} </v-tab>
                </v-tabs>
              </v-col>
              <v-col cols="12" xs="12" sm="6" class="text-right">
                <v-radio-group
                  v-if="tab === 'tab-0' && certsConfig.withAuthorized"
                  v-model="radioGroup"
                  row
                >
                  <v-radio label="See all" value="see-all"></v-radio>
                  <v-radio
                    label="See authorized"
                    value="see-authorized"
                  ></v-radio>
                  <v-radio
                    label="See unauthorized"
                    value="see-unauthorized"
                  ></v-radio>
                </v-radio-group>
              </v-col>
              <v-col cols="12" xs="12" sm="6" class="text-right">
                <v-btn
                  v-if="tab === 'tab-0' && certsConfig.withAuthorized"
                  :disabled="selected.length <= 0"
                  :block="$vuetify.breakpoint.smAndDown"
                  :class="
                    ({ 'mr-2': $vuetify.breakpoint.mdAndUp }, 'text-none')
                  "
                  :loading="isSendEmailsLoading"
                  outlined
                  color="primary"
                  small
                  data-cy="certify"
                  @click="sendEmails()"
                >
                  <v-icon left dark> mdi-email-send </v-icon>
                  {{ $t('sendAuthorization') }}
                </v-btn>
                <v-btn
                  v-if="tab === 'tab-0'"
                  :disabled="selected.length <= 0"
                  :block="$vuetify.breakpoint.smAndDown"
                  :class="
                    ({ 'mr-2': $vuetify.breakpoint.mdAndUp }, 'text-none')
                  "
                  :loading="isCertifyLoading"
                  color="primary"
                  small
                  data-cy="certify"
                  @click="certify"
                >
                  {{ $t('certify-btn') }}
                </v-btn>
                <!-- <v-btn
                  v-else-if="tab === 'tab-1'"
                  :disabled="selected.length <= 0"
                  :block="$vuetify.breakpoint.smAndDown"
                  :class="{ 'mr-2': $vuetify.breakpoint.mdAndUp }"
                  color="primary"
                  small
                  @click="downloadQr()"
                >
                  {{ $t('downloadQr') }}
                </v-btn> -->
                <v-btn
                  v-else-if="tab === 'tab-2'"
                  :disabled="selected.length <= 0"
                  :block="$vuetify.breakpoint.smAndDown"
                  :class="
                    ({ 'mr-2': $vuetify.breakpoint.mdAndUp }, 'text-none')
                  "
                  color="primary"
                  small
                  @click="unrevoke"
                >
                  {{ $t('revalidate') }}
                </v-btn>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" class="pa-0">
                <v-tabs-items v-model="tab">
                  <v-tab-item :key="0" :value="'tab-0'">
                    <DataTableCertificates
                      :headers="headers"
                      :items="
                        radioGroup === 'see-all'
                          ? newData
                          : radioGroup === 'see-authorized'
                          ? newDataAuthorized
                          : newDataUnauthorized
                      "
                      :tab="'tab-0'"
                      :delete-activate="true"
                      :search="search"
                      :is-sending-emails="isSendEmailsLoading"
                      :with-authorized="certsConfig.withAuthorized"
                      @change="selected = $event"
                      @deleteItem="deleteItem($event)"
                    />
                  </v-tab-item>
                  <v-tab-item :key="1" :value="'tab-1'">
                    <DataTableCertificates
                      :headers="headers"
                      :items="certificatedData"
                      :search="search"
                      :tab="'tab-1'"
                      :archive-activate="true"
                      @change="selected = $event"
                      @archiveItem="archiveItem($event)"
                    />
                  </v-tab-item>
                  <v-tab-item :key="2" :value="'tab-2'">
                    <DataTableCertificates
                      :headers="headers"
                      :items="revocatedData"
                      :search="search"
                      :revalidate-activate="true"
                      @change="selected = $event"
                    />
                  </v-tab-item>
                </v-tabs-items>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-dialog v-model="dialogSendMultipleLoading" persistent max-width="290">
      <v-card>
        <v-card-title>
          <v-spacer></v-spacer>
          <v-progress-circular indeterminate color="blue"></v-progress-circular>
          <v-spacer></v-spacer>
        </v-card-title>
        <v-card-text class="text-center text-h5 primary--text">
          {{ $t('emails-loading') }}
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogSendMultiple" persistent max-width="290">
      <v-card>
        <v-card-title>
          <v-spacer></v-spacer>
          <v-icon color="primary" large>mdi-email-send</v-icon>
          <v-spacer></v-spacer>
        </v-card-title>
        <v-card-text class="text-center text-h5 primary--text">
          Email sent to <strong>{{ selected.length }}</strong> contacts for
          authorization
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" small @click="dialogSendMultiple = false">
            Close
          </v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-snackbar
      v-model="snackbar.show"
      :top="snackbar.top"
      :right="snackbar.right"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </v-container>
</template>

<script lang="ts">
import { mapGetters } from 'vuex'
import moment from 'moment'
import * as Papa from 'papaparse'
import _ from 'lodash'
import swal from 'sweetalert'

import SendEmailVerificationMixin from '@/mixins/SendEmailVerificationMixin'
import DataTableCertificates from '~/components/Certificates/DataTableCertificates.vue'
import UploadData from '~/components/Certificates/UploadData.vue'
import MisionesBonosVerdesCerts from '~/components/Certificates/MisionesBonosVerdesCerts.vue'
import MisionesFondoDeCredito from '~/components/Certificates/MisionesFondoDeCredito.vue'
import Dervinsa6a138 from '~/components/Certificates/Dervinsa6a138.vue'

import { FReader } from '~/plugins/fileReader'

import { saveFile } from '~/services/Firebase'
import {
  setBatchCertificates,
  deleteCertificate,
  deleteNotifications,
  updateCertificate,
  getAllCertificates,
  updateBatchCertificates,
} from '~/services/Certificates'

export default SendEmailVerificationMixin.extend({
  name: 'Certificates',
  components: {
    MisionesBonosVerdesCerts,
    DataTableCertificates,
    UploadData,
    MisionesFondoDeCredito,
    Dervinsa6a138,
  },
  mixins: [],
  middleware: ['admin'],
  props: {},
  data: () => ({
    dialogSendMultipleLoading: false,
    isSendEmailsLoading: false,
    isCertifyLoading: false,
    tab: 'tab-0',
    search: '',
    selected: [],
    headers: [] as any,
    certificatedData: [] as any,
    newData: [] as any,
    newDataAuthorized: [] as any,
    newDataUnauthorized: [] as any,
    revocatedData: [] as any,
    dialogNew: false,
    rules: [(v: any) => !!v || 'El campo es requerido'],
    rulesNumber: [
      (v: any) => !!v || 'El campo es requerido',
      (v: number) => !(v < 0) || 'El numero no puede ser menor que 0',
    ],
    snackbar: {
      show: false,
      color: '',
      mode: '',
      timeout: 12000,
      text: '',
      right: '',
      top: '',
    },
    listRemoveKeys: [
      'is_certified',
      'is_revocated',
      'id_reference',
      'certify',
      'pubkey',
      'name',
      'identity',
      'ref',
      'created',
      'estado_origen',
      'link',
      'type',
      'authorized',
      'pagoPrimeraCuota',
      'plazo_total',
      'dateFinPG',
      'pdf',
    ],
    componentName: process.env.FIREBASE_PROJECT_ID,
    radioGroup: 'see-all',
    dialogSendMultiple: false,
    dialogSend: false,
  }),
  computed: {
    currentComponente(): any {
      if (this.componentName) {
        const comp = this.componentName
          .trim()
          .replace(/\b\w/g, function (l: any) {
            return l.toUpperCase()
          })
          .replace(/\b-/g, '')
        return comp
      } else {
        return null
      }
    },
    ...mapGetters({
      certsConfig: 'certsConfig/certsConfig',
    }),
  },
  beforeMount() {
    this.getData()
  },
  methods: {
    async sendEmails(): Promise<void> {
      this.isSendEmailsLoading = true
      const selectedAreAuthorized = this.selected.some(
        (certificate: any) => certificate.authorized === 'Authorized'
      )

      if (!selectedAreAuthorized) {
        this.dialogSendMultipleLoading = true
        const personalizations = [] as Array<Object>
        try {
          const tokenURLs = await this.createMultipleTokenAuthorization(
            this.selected
          )
          if (tokenURLs.length > 0) {
            tokenURLs.forEach((participant: any) => {
              personalizations.push({
                to: [
                  {
                    email: participant.email,
                  },
                ],
                dynamic_template_data: {
                  user: participant.email,
                  link: participant.linkToAuthorize,
                },
                subject: 'Verification Email - UNICEF',
              })
            })
            try {
              await this.sendMultipleEmails(personalizations)
              this.dialogSendMultipleLoading = false
              this.dialogSendMultiple = true
            } catch (error) {
              this.dialogSendMultipleLoading = false
              swal({
                title: `Sorry, the e-mails couldn't be sent`,
                text: error,
                icon: 'error',
                buttons: 'Close',
              })
            }
          }
        } catch (error) {
          this.dialogSendMultipleLoading = false
          swal({
            title: `Sorry, the e-mails couldn't be sent`,
            text: error,
            icon: 'error',
            buttons: 'Close',
          })
        }
      } else {
        swal({
          title: `Sorry, the e-mails couldn't be sent`,
          text: 'The selected certificates must not be authorized.',
          icon: 'error',
          buttons: 'Close',
        })
      }
      this.isSendEmailsLoading = false
    },
    resetData(): any {
      this.certificatedData = []
      this.newData = []
      this.revocatedData = []
      this.headers = []
    },
    async getData() {
      try {
        this.resetData()
        const certificates = await getAllCertificates(
          this.$fire,
          'certificates'
        )
        if (!certificates.empty) {
          this.headers = this.getHeaders(certificates.docs[0].data())
          if (this.certsConfig.withAuthorized) {
            this.headers.push({
              sortable: true,
              text: 'Authorized',
              value: 'authorized',
              width: 100,
            })
          }
          certificates.forEach(
            (doc: { ref: { path: any }; data: () => any }) => {
              const data = {
                ref: doc.ref.path,
                ...doc.data(),
              } as any
              if (data.is_certified || data.certify) {
                if (data.is_revocated) {
                  this.revocatedData.push(data)
                } else {
                  this.certificatedData.push(data)
                }
              } else {
                if (this.certsConfig.withAuthorized) {
                  // Check if data has authorized info
                  if (!('authorized' in data) || data.authorized === false) {
                    data.authorized = 'Unauthorized'
                  } else {
                    data.authorized = 'Authorized'
                  }

                  if (data.authorized === 'Authorized')
                    this.newDataAuthorized.push(data)
                  else if (data.authorized === 'Unauthorized')
                    this.newDataUnauthorized.push(data)
                }
                this.newData.push(data)
              }
            }
          )
        }
      } catch (error) {
        console.error(error)
        this.snackbar.show = true
        this.snackbar.text = error
        this.snackbar.color = 'error'
      }
    },
    getHeaders(object: any, onlykeys?: boolean) {
      const keys = Object.keys(object)
      const nameKeys = keys
        // eslint-disable-next-line array-callback-return
        .filter((element: string) => {
          if (!this.listRemoveKeys.includes(element)) {
            return element
          }
        })
      if (onlykeys) {
        return nameKeys
      } else {
        return nameKeys.map((element) => ({
          text: (element.charAt(0).toUpperCase() + element.slice(1)).replace(
            '_',
            ' '
          ),
          value: element,
          sortable: true,
          width: 170,
        }))
      }
    },
    validateColumnsNames(contentCsv: Array<object>) {
      const currentHeaders = this.getHeaders(
        this.newData[0],
        true
      ) as Array<string>
      const csvHeaders = this.getHeaders(contentCsv[0], true) as Array<string>
      const checkHeaders = currentHeaders.every((v: any) =>
        csvHeaders.includes(v)
      )
      return checkHeaders
    },
    async saveData(files: any) {
      if (files.length > 0) {
        try {
          const self = this
          let content
          if (files[0].file.type === 'text/csv') {
            content = await FReader.readCSV(files[0].file)
          } else {
            content = await FReader.readExcel(files[0].file)
          }
          let valid = true
          if (this.newData.length > 0) {
            valid = await this.validateColumnsNames(content)
          }
          if (valid) {
            await setBatchCertificates(
              self.$fire,
              content,
              'certificates',
              self.$store
            )
            this.showMessages({
              error: false,
              message: this.$t('uploadData.saved_data_success'),
            })
            this.getData()
            this.dialogNew = false
          } else {
            this.showMessages({
              error: true,
              message: this.$t('uploadData.saved_keys_error'),
            })
          }
        } catch {
          this.showMessages({
            error: true,
            message: this.$t('uploadData.saved_data_error'),
          })
        }
        this.loading = false
      }
    },
    async pastedData(pastedData: any) {
      try {
        const rows = pastedData.split('\n')
        const cellObjArray: any[] = []
        let headersCellObj: string[] = []
        for (const y in rows) {
          const cells = rows[y].split('\t')
          if (+y === 0) {
            /** First row, used for headers */
            headersCellObj = cells
          } else {
            /** Parse pasted rows to JSON objects */
            const cellObj = cells.reduce(
              (
                previousObject: object,
                currentValue: string,
                currentIndex: number
              ) => {
                const key = headersCellObj[currentIndex]
                  .toLowerCase()
                  .trim()
                  .normalize('NFD')
                  .replace(/[\u0300-\u036F]/g, '')
                  .split(' ')
                  .join('_')
                const value = currentValue
                return Object.assign(previousObject, {
                  [key]: value,
                })
              },
              {}
            )
            if (
              !cellObjArray[0] ||
              Object.keys(cellObj).length >= Object.keys(cellObjArray[0]).length
            ) {
              cellObjArray.push(cellObj)
            }
          }
        }
        let valid = true
        if (this.newData.length > 0) {
          valid = await this.validateColumnsNames(cellObjArray)
        }
        if (valid) {
          setBatchCertificates(
            this.$fire,
            cellObjArray,
            'certificates',
            this.$store
          )
          this.showMessages({
            error: false,
            message: this.$t('uploadData.saved_data_success'),
          })
          this.getData()
          this.dialogNew = false
        } else {
          this.showMessages({
            error: true,
            message: this.$t('uploadData.saved_keys_error'),
          })
        }
      } catch (error) {
        this.showMessages({
          error: true,
          message: this.$t('uploadData.saved_data_error'),
        })
      }
      this.loading = false
    },
    async certify() {
      this.isCertifyLoading = true

      // Check if certificates are authorized (if needed)
      let selectedAreAuthorized = null
      if (this.certsConfig.withAuthorized) {
        selectedAreAuthorized = this.selected.some(
          (certificate: any) =>
            certificate.authorized === true ||
            certificate.authorized === 'Authorized'
        )
      } else {
        selectedAreAuthorized = true
      }
      if (selectedAreAuthorized) {
        try {
          const items = _.cloneDeep(this.selected)
          items.forEach((item: any) => {
            item.id_reference = item.ref.split('/')[1]
            item.certify = true
            item.estado_origen = 'En espera'
          })
          await updateBatchCertificates(this.$fire, items, 'certificates')
          this.createCsv(items)
          this.getData()
          swal({
            title: `${this.$t('certifying')}`,
            text: `${this.$t('certifying-sub')}`,
            icon: 'success',
            button: `${this.$t('aceptar')}`,
          })
        } catch (error) {
          console.error(error)
          this.snackbar.show = true
          this.snackbar.text = `${this.$t('certifying-err')}`
          this.snackbar.color = 'error'
        }
      } else {
        swal({
          title: `Sorry, the certificates couldn't be certified.`,
          text: 'The selected certificates must be authorized.',
          icon: 'error',
          buttons: 'Close',
        })
      }
      this.isCertifyLoading = false
    },
    createCsv(data: any[]) {
      data.forEach((element) => {
        element.id_reference = element.ref.split('/')[1]
        delete element.ref
        delete element.certify
        delete element.is_certified
        delete element.is_revocated
        delete element.created
        delete element.estado_origen
        delete element.authorized
        delete element.plazo_total
        delete element.dateFinPG
        delete element.pagoPrimeraCuota
        element.email = element.email ? element.email : ''
        if (this.componentName === 'unicef-certs')
          element.course_type = element.course_type ? element.course_type : ''
      })
      const i = Papa.unparse(data)
      const file = new Blob(['\uFEFF', i], {
        type: 'data:text/csv;charset=utf-8',
      }) as any
      const date = moment().format('YYYY_MM_DD_HH_mm')
      file.name = `certificates_${date}.csv`
      saveFile(this.$fireModule, file, 'certificates')
    },
    async deleteItem(item: any) {
      try {
        const id = item.ref.split('/')[1]
        const email = item.email
        await deleteCertificate(this.$fire, id)
        await deleteNotifications(this.$fire, email)
        this.snackbar.show = true
        this.snackbar.text = this.$t(
          'certificates.record_deleted_success'
        ).toString()
        this.snackbar.color = 'success'
        this.getData()
      } catch (error) {
        console.error(error)
        this.snackbar.show = true
        this.snackbar.text = this.$t(
          'certificates.record_deleted_error'
        ).toString()
        this.snackbar.color = 'error'
      }
    },
    async archiveItem(item: any) {
      try {
        item.estado_origen = 'Revocado'
        item.is_revocated = true
        const id = item.ref.split('/')[1]
        await updateCertificate(this.$fire, id, item, 'certificates')
        this.getData()
        this.snackbar.show = true
        this.snackbar.text = this.$t(
          'certificates.record_revoke_success'
        ).toString()
        this.snackbar.color = 'success'
      } catch (error) {
        console.error(error)
        this.snackbar.show = true
        this.snackbar.text = this.$t(
          'certificates.record_revoke_error'
        ).toString()
        this.snackbar.color = 'error'
      }
    },
    async unrevoke() {
      try {
        const items = _.cloneDeep(this.selected)
        items.forEach((item: any) => {
          item.id_reference = item.ref.split('/')[1]
          item.is_revocated = false
          item.estado_origen = 'Certificado'
        })
        await updateBatchCertificates(this.$fire, items, 'certificates')
        this.getData()
        swal({
          title: this.$t('certificates.certifying'),
          text: this.$t('certificates.data_is_being_certified'),
          icon: 'success',
          button: this.$t('aceptar'),
        })
      } catch {
        this.snackbar.show = true
        this.snackbar.text = this.$t(
          'certificates.data_not_revalidated'
        ).toString()
        this.snackbar.color = 'error'
      }
    },
    showMessages(response: { error: any; message: any }) {
      if (response.error) {
        this.snackbar.color = 'error'
      } else {
        this.snackbar.color = 'success'
      }
      this.snackbar.text = response.message
      this.snackbar.show = true
    },
  },
})
</script>
